/*
 * This Cplant(TM) source code is part of the Portals3 Reference
 * Implementation.
 *
 * This Cplant(TM) source code is the property of Sandia National
 * Laboratories.
 *
 * This Cplant(TM) source code is copyrighted by Sandia National
 * Laboratories.
 *
 * The redistribution of this Cplant(TM) source code is subject to the
 * terms of version 2 of the GNU General Public License.
 * (See COPYING, or http://www.gnu.org/licenses/lgpl.html.)
 *
 * Cplant(TM) Copyright 1998-2006 Sandia Corporation. 
 *
 * Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
 * license for use of this work by or on behalf of the US Government.
 * Export of this program may require a license from the United States
 * Government.
 */


/* Portals3 is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License,
 * as published by the Free Software Foundation.
 *
 * Portals3 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portals3; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Questions or comments about this library should be sent to:
 *
 * Jim Schutt
 * Sandia National Laboratories, New Mexico
 * P.O. Box 5800
 * Albuquerque, NM 87185-0806
 *
 * jaschut@sandia.gov
 *
 */

#ifndef _PTL3_LIB_DISPATCH_H_
#define _PTL3_LIB_DISPATCH_H_

typedef struct dispatch_table {
	void (*fun)(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
	char *name;
} dispatch_table_t;

extern dispatch_table_t dispatch_table[];

extern void lib_PtlACEntry	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlEQAlloc	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlEQFree	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlFini		(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlGet		(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlGetJid	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlGetId	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlGetPut	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlGetUid	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlInit		(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMDAttach	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMDBind	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMDUnlink	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMDUpdate	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMEAttach	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMEAttachAny	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMEDump	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMEInsert	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlMEUnlink	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlNIDebug	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlNIDist	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlNIFini	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlNIInit	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlNIStatus	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlProgress	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlPut		(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlSetPid	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);
extern void lib_PtlTblDump	(lib_ni_t *, p3_libreq_t *, p3_libres_t *);

#endif /* _PTL3_LIB_DISPATCH_H_ */
