
/* This file duplicates for kernel space functionality available in the
 * user-space include file, inttypes.h
 */

#ifndef _PTL3_INTTYPES_H_
#define _PTL3_INTTYPES_H_

#include <linux/types.h>

#define PRIi32  "i"
#define PRIu32  "u"
#define PRIo32  "o"
#define PRIx32  "x"
#define PRIX32  "X"

#if UINT64_T_IS_ULONGLONG

#define PRIi64  "lli"
#define PRIu64  "llu"
#define PRIo64  "llo"
#define PRIx64  "llx"
#define PRIX64  "llX"

#elif UINT64_T_IS_ULONG

#define PRIi64  "li"
#define PRIu64  "lu"
#define PRIo64  "lo"
#define PRIx64  "lx"
#define PRIX64  "lX"

#elif UINT64_T_IS_UINT

#define PRIi64  "i"
#define PRIu64  "u"
#define PRIo64  "o"
#define PRIx64  "x"
#define PRIX64  "X"

#endif

#endif /* _PTL3_INTTYPES_H_ */
