/*
 * This Cplant(TM) source code is part of the Portals3 Reference
 * Implementation.
 *
 * This Cplant(TM) source code is the property of Sandia National
 * Laboratories.
 *
 * This Cplant(TM) source code is copyrighted by Sandia National
 * Laboratories.
 *
 * The redistribution of this Cplant(TM) source code is subject to the
 * terms of version 2 of the GNU General Public License.
 * (See COPYING, or http://www.gnu.org/licenses/lgpl.html.)
 *
 * Cplant(TM) Copyright 1998-2006 Sandia Corporation. 
 *
 * Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
 * license for use of this work by or on behalf of the US Government.
 * Export of this program may require a license from the United States
 * Government.
 */


/* Portals3 is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License,
 * as published by the Free Software Foundation.
 *
 * Portals3 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portals3; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Questions or comments about this library should be sent to:
 *
 * Jim Schutt
 * Sandia National Laboratories, New Mexico
 * P.O. Box 5800
 * Albuquerque, NM 87185-0806
 *
 * jaschut@sandia.gov
 *
 */
#include <linux/kdev_t.h>

#ifndef _PTL3_KERN_P3_MODULE_H_
#define _PTL3_KERN_P3_MODULE_H_

extern struct class p3_class;

/* We'll use one major number, and multiple minor numbers, for the various
 * Portals device files needed.
 */
extern dev_t p3_dev;

#define P3LIB_MINOR   0
#define P3RT_MINOR    1
#define P3_NUM_MINORS 2

#define P3LIB_DEV MKDEV(MAJOR(p3_dev),P3LIB_MINOR)
#define P3RT_DEV  MKDEV(MAJOR(p3_dev),P3RT_MINOR)

#define P3LIB_MAJOR MAJOR(p3_dev)
#define P3RT_MAJOR  MAJOR(p3_dev)

/* We'll want to have all the library and NAL modules show up under a
 * "portals3" class in /sys/class, so we need to make the class struct
 * available to them all.
 */
extern struct class p3_class;

#endif /* _PTL3_KERN_P3_MODULE_H_ */
