/*
 * This Cplant(TM) source code is part of the Portals3 Reference
 * Implementation.
 *
 * This Cplant(TM) source code is the property of Sandia National
 * Laboratories.
 *
 * This Cplant(TM) source code is copyrighted by Sandia National
 * Laboratories.
 *
 * The redistribution of this Cplant(TM) source code is subject to the
 * terms of version 2 of the GNU General Public License.
 * (See COPYING, or http://www.gnu.org/licenses/lgpl.html.)
 *
 * Cplant(TM) Copyright 1998-2006 Sandia Corporation. 
 *
 * Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
 * license for use of this work by or on behalf of the US Government.
 * Export of this program may require a license from the United States
 * Government.
 */


/* Portals3 is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License,
 * as published by the Free Software Foundation.
 *
 * Portals3 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portals3; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Questions or comments about this library should be sent to:
 *
 * Jim Schutt
 * Sandia National Laboratories, New Mexico
 * P.O. Box 5800
 * Albuquerque, NM 87185-0806
 *
 * jaschut@sandia.gov
 *
 */

#ifndef _PTL3_KERN_P3LIB_MODULE_H_
#define _PTL3_KERN_P3LIB_MODULE_H_

#include "hash_int.h"

#define P3_PROCESS_HASH_BITS 5
#define P3_PROCESS_HASH_BINS (1U << P3_PROCESS_HASH_BITS)

extern struct list_head p3proc_pid_hash[P3_PROCESS_HASH_BINS];
extern struct list_head p3proc_tsk_hash[P3_PROCESS_HASH_BINS];

#define p3proc_pid_listhead(pid) \
        (p3proc_pid_hash + hash32(pid,P3_PROCESS_HASH_BITS))

#define p3proc_tsk_listhead(task_ptr) \
        (p3proc_tsk_hash + hash64(((long)task_ptr),P3_PROCESS_HASH_BITS))


#endif /* _PTL3_KERN_P3LIB_MODULE_H_ */
