
/* This file duplicates for kernel space functionality available in the
 * user-space include file, inttypes.h
 */

#ifndef _PTL3_STDINT_H_
#define _PTL3_STDINT_H_

#include <linux/types.h>

#define UINT8_C(c)  c ## U
#define UINT16_C(c) c ## U
#define UINT32_C(c) c ## U

#define INT8_C(c)   c
#define INT16_C(c)  c
#define INT32_C(c)  c

#if BITS_PER_LONG == 32

#define INT64_C(c)  c ##  LL
#define UINT64_C(c) c ## ULL

#elif BITS_PER_LONG == 64

#define INT64_C(c)  c ##  L
#define UINT64_C(c) c ## UL

#endif

/* The C standard says CHAR_BIT should be in limits.h, but the kernel
 * linux/limits.h doesn't have it.
 *
 * So, we'll put it here.
 */
#define CHAR_BIT 8

#endif /* _PTL3_STDINT_H_ */
