/*
 * This Cplant(TM) source code is part of the Portals3 Reference
 * Implementation.
 *
 * This Cplant(TM) source code is the property of Sandia National
 * Laboratories.
 *
 * This Cplant(TM) source code is copyrighted by Sandia National
 * Laboratories.
 *
 * The redistribution of this Cplant(TM) source code is subject to the
 * terms of version 2 of the GNU General Public License.
 * (See COPYING, or http://www.gnu.org/licenses/lgpl.html.)
 *
 * Cplant(TM) Copyright 1998-2006 Sandia Corporation. 
 *
 * Under the terms of Contract DE-AC04-94AL85000, there is a non-exclusive
 * license for use of this work by or on behalf of the US Government.
 * Export of this program may require a license from the United States
 * Government.
 */


/* Portals3 is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License,
 * as published by the Free Software Foundation.
 *
 * Portals3 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portals3; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Questions or comments about this library should be sent to:
 *
 * Jim Schutt
 * Sandia National Laboratories, New Mexico
 * P.O. Box 5800
 * Albuquerque, NM 87185-0806
 *
 * jaschut@sandia.gov
 *
 */


#ifndef __P3TCP_MODULE_H__
#define __P3TCP_MODULE_H__

extern unsigned int p3tcp_debug;

extern unsigned p3tcp_if_count;
extern char p3tcp_if_name[MAX_P3TCP_IF][MAX_P3TCP_IFNAME];

struct p3tcp_kthread {
	ptl_interface_t type;
	struct task_struct *progress_task;
	struct semaphore sem;
	unsigned long flags;		/* use set_bit() and friends */
	char name[MAX_P3TCP_IFNAME];	/* thread name */
};
extern struct p3tcp_kthread p3tcp_kthread[MAX_P3TCP_IF];

void p3tcp_wakeup(struct p3tcp_kthread *thread);

/* Use these for bitops.h operations, i.e. set_bit() and friends
 */
#define P3TCP_KTHREAD_RUNNING 1
#define P3TCP_KTHREAD_STOP    2
#define P3TCP_KTHREAD_ERROR   3


#endif
